
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; MODULE      : xmltm.scm
;; DESCRIPTION : conversion of Xml trees to TeXmacs trees
;; COPYRIGHT   : (C) 2003  Joris van der Hoeven
;;
;; This software falls under the GNU general public license and comes WITHOUT
;; ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for details.
;; If you don't have this file, write to the Free Software Foundation, Inc.,
;; 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(texmacs-module (convert xmltm xmltm)
  (:export xml->object))

(define (xmltm-file x)

(define (tmxml-string s)
  (set! s (string-replace s "&" "<"))
  (set! s (string-replace s ";" ">"))
  (set! s (string-replace s "<amp>" ";"))
  s)

(define (xmltm x)
  (cond ((string? x) (xmltm-string x))
	((func? x 'TeXmacs 1) (xmltm-file (cadr x)))
	((func? x 'document) (xmltm-document (cdr x)))
	((func? x 'concat) (xmltm-concat (cdr x)))
	((and (or (func? x 'apply) (func? x 'expand)) (string? (cadr x)))
	 (xmltm-apply (symbol->string (car x))
		      (string->symbol (cadr x))
		      (cddr x)))
	((func? x 'with) (xmltm-with (cdr x)))
	(else (xmltm-regular (car x) (cdr x)))))

(tm-define (xml->object x)
  (:type (object -> object))
  (:synopsis "Convert the XML tree @x into a TeXmacs tree.")
  (cond ((func

  (list (stm-unary-document (xml->tree s)) 'browser))
